# -*- coding: utf-8 -*-
import re, json, time
try:
	from urllib2 import urlopen, Request
except ImportError:
	from urllib.request import urlopen, Request
try:
	from urllib import quote
except ImportError:
	from urllib.parse import quote
try:
	from urlparse import urlparse
except ImportError:
	from urllib.parse import urlparse
try:
	from HTMLParser import HTMLParser
except ImportError:
	from html.parser import HTMLParser

def httpget(url, referer = None):
	try:
		request = Request(url)
		if referer != None:
			request.add_header('Referer', referer)
		content = urlopen(request, timeout = 10).read().decode('utf-8')
		return content
	except:
		print(url)
		print('captured')
		return False

def show_page(url):
	o = urlparse(url)
	id = re.search('/show_page/id_(.*?)\.html', o.path)
	if id == None:
		return {'success': False, 'code': 'youku 200'}
	id = id.group(1)
	url = 'http://list.youku.com/show/id_' + id + '.html'
	return list_show_id(url)

def list_show_id(url):
	o = urlparse(url)
	id = re.search('/show/id_(.*?)\.html', o.path)
	if id == None:
		return {'success': False, 'code': 'youku 200'}
	id = id.group(1)
	url = 'http://list.youku.com/show/id_' + id + '.html'
	content = httpget(url)
	if content == False:
		return {'success': False, 'code': 'youku 201'}
	showid = re.search('showid:"(.*?)"', content)
	if showid == None:
		return {'success': False, 'code': 'youku 202'}
	showid = showid.group(1)
	url = 'http://list.youku.com/show/module?id=' + showid + '&tab=showInfo&callback=callback'
	content = httpget(url)
	if content == False:
		return {'success': False, 'code': 'youku 203'}
	content = re.search('\((.*)\)', content)
	if content == None:
		return {'success': False, 'code': 'youku 204'}
	content = content.group(1)
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code': 'youku 205'}
	html = data['html']
	result = {'success': True, 'item': []}
	ul = re.search('<ul.*?>(.*?)</ul>', html)
	if ul == None:
		return {'success': False, 'code': 'youku 206'}
	ul = ul.group(1)
	m = re.findall('<li(.*?)>(.*?)</li>', ul)
	if m:
		for e in m:
			dataid = re.search('data-id="(.*?)"', e[0])
			if dataid:
				dataid = dataid.group(1)
				url = 'http://list.youku.com/show/episode?id=' + showid + '&stage=' + dataid + '&callback=callback'
				result['item'].append({'title': HTMLParser().unescape(e[1]), 'url': url})
			a = re.search('<a(.*?)>(.*?)</a>', e[1])
			if a:
				href = re.search('href="(.*?)"', a.group(1))
				if href:
					url = href.group(1)
					if url[0:2] == '//':
						url = 'http:' + url
					result['item'].append({'title': HTMLParser().unescape(a.group(2)), 'url': url})
	return result

def list_show_episode(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code': 'youku 220'}
	content = re.search('\((.*)\)', content)
	if content == None:
		return {'success': False, 'code': 'youku 221'}
	content = content.group(1)
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code': 'youku 222'}
	html = data['html']
	result = {'success': True, 'item': []}
	m = re.findall('<li.*?>(.*?)</li>', html)
	if m:
		m.reverse()
		for e in m:
			title = HTMLParser().unescape(re.sub('<.*?>', '', e))
			e1 = re.search('<a.*?href="(.*?)".*?>', e)
			if e1 == None:
				continue
			url = e1.group(1)
			if url[0:2] == '//':
				url = 'http:' + url
			result['item'].append({'title': title, 'url': url})
	return result

def show_episode(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code': 'youku 300'}
	result = {'success': True, 'item': []}
	m = re.findall('<ul.*?>(.*?)</ul>', content, re.DOTALL)
	for e in m:
		s = re.search('<a [^<>]*href="(.*?)"[^<>]*>(.*?)</a>', e)
		if s == None:
			continue
		result['item'].append({'title': HTMLParser().unescape(s.group(2)), 'url': s.group(1)})
	return result

def playlist_show(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code': 'youku 400'}
	result = {'success': True, 'item': []}
	m = re.findall('<ul class="v">(.*?)</ul>', content, re.DOTALL)
	for e in m:
		s = re.search('<a [^<>]*title="(.*?)"[^<>]*href="(.*?)"[^<>]*>', e)
		if s == None:
			continue
		result['item'].append({'title': HTMLParser().unescape(s.group(1)), 'url': s.group(2)})
	s = re.search('<div class="page f_r">(.*?)</div>', content, re.DOTALL)
	if s:
		s = re.search('<a [^<>]*href="(.*?)"[^<>]*title=\'下一页\'[^<>]*>', s.group(1))
		if s:
			result['item'].append({'title': 'Load more', 'url': s.group(1)})
	return result

def play(url):
	def quote_cna(cna):
		if '%' in cna:
			return cna
		return quote(cna)
	def fetch_cna():
		#return 'FwxJFKUKpkoCAW6vuatKK0fS'
		url = 'http://log.mmstat.com/eg.js'
		try:
			req = urlopen(url)
		except e:
			raise e
		for header in req.info():
			if header.lower() == 'set-cookie':
				n_v = req.info()[header].split(';')[0]
				name, value = n_v.split('=')
				if name == 'cna':
					return quote_cna(value)
		return quote_cna('FwxJFKUKpkoCAW6vuatKK0fS')
	o = urlparse(url)
	if o.netloc != 'v.youku.com':
		return {'success': False, 'code': 'youku 100'}
	vid = re.search('/v_show/id_(.*?)\.html', o.path)
	if vid == None:
		return {'success': False, 'code': 'youku 100'}
	vid = vid.group(1)
	try:
		test = fetch_cna()
	except:
		return {'success': False, 'code': 'youku 101'}
	ccode = '0524'
	for i in range(524, 525):
		ccode = '%04d' % i
		url = 'https://ups.youku.com/ups/get.json?vid=' + vid + '&ccode=' + ccode
		url += '&client_ip=192.168.1.1'
		url += '&utid=' + test
		url += '&client_ts=' + str(int(time.time()))
		content = httpget(url, referer = 'https://v.youku.com')
		if content == False:
			return {'success': False, 'code': 'youku 102'}
		#f = open('temp/%s.json' % ccode, 'wb')
		#f.write(content.encode('utf-8'))
		#f.close()
		#continue
		try:
			data = json.loads(content)
		except:
			return {'success': False, 'code': 'youku 103'}
		try:
			result = {'success': True, 'title': data['data']['video']['title'], 'url': {}}
			for stream in data['data']['stream']:
				result['url'][stream['stream_type']] = []
				for seg in stream['segs']:
					result['url'][stream['stream_type']].append({'url': seg['cdn_url'], 'size': seg['size']})
		except:
			try:
				return {'success': False, 'code': data['data']['error']['note']}
			except:
				return {'success': False, 'code': 'youku 104'}
	return result
